<template>
  <label :for="name">
    {{ label }}
    <textarea
      v-if="type === 'textarea'"
      v-model="value"
      :disabled="isReadonly"
      :name="name"
    />
    <input
      v-else
      :type="type"
      v-model="value"
      :disabled="isReadonly"
      :name="name"
      :class="{ 'input-error': validationMsg }"
    />
    <p class="error" v-if="validationMsg">{{ validationMsg }}</p>
  </label>
</template>

<script lang="ts">
import { defineComponent } from "vue";

export default defineComponent({
  name: "ReInput",
  emits: ["update:modelValue"],
  props: {
    label: {
      type: String,
    },
    type: {
      type: String,
      default: "text",
      validator(inputType: string) {
        return [
          "text",
          "email",
          "password",
          "number",
          "search",
          "textarea",
        ].includes(inputType);
      },
    },
    validationMsg: String,

    isReadonly: Boolean,
    modelValue: {
      type: [String, Number],
    },
    name: { type: String, default: "" },
  },
  computed: {
    value: {
      get() {
        return this.modelValue;
      },
      set(value: string | number) {
        this.$emit("update:modelValue", value);
      },
    },
  },
});
</script>
<!-- <style scoped>
div {
  display: flex;
  flex-direction: column;
}
label {
  font-weight: bold;
  margin-bottom: 0.5rem;
}
textarea,
input {
  padding: 0.5rem;
  border: 1px solid #ccc;
  resize: none;
  transition: border-color 0.2s ease-in;
}

input {
  max-width: 300px;
}

[disabled] {
  background-color: #fff;
  border-color: #fff;
  max-width: 100%;
}

textarea {
  height: 80px;
}

p {
  height: 33px;
}

.input-error {
  border-color: #ff3f3f;
  outline-color: #ff3f3f;
}
</style> -->
